/*********************************************
 * OPL 12.6.2.0 Model
 * Author: John
 * Creation Date: Oct 23, 2015 at 3:25:24 PM
 *********************************************/

 using CP;
 
 int nPatients = ...;
 int nNurses = ...;
 range Patients = 1..nPatients;
 range Nurses = 1..nNurses;
 
 int travelTime[Patients][Patients] = ...;
 int duration[Patients] = ...;
 int release[Patients] = ...;
 int deadline[Patients] = ...;
 int assignBar[Patients] = ...;
 setof(int) thesePatients = { j | j in Patients : assignBar[j]==1 };
 int homeBase[1..2] = ...;
 
 tuple triplet {int t1; int t2; int v;}
 {triplet} travelTimes =
  { <t1,t2,travelTime[t1][t2]> | t1,t2 in thesePatients };
 
 int patientType[thesePatients];
 
 dvar interval a[j in thesePatients] in release[j]..deadline[j] size duration[j];
 dvar sequence s in a types patientType;
 dvar int dummy;
 
 execute {
   for(var j in thesePatients) patientType[j] = j;  
 }
 
 minimize 
   dummy;
   
 subject to {
   dummy == 1;
   first(s,a[homeBase[1]]);
   last(s,a[homeBase[2]]);
   noOverlap(s, travelTimes, 1); 
}  

execute {
  writeln(s);
  writeln(a);
}